=== debian/changelog ===
osm2pgsql (2.0.1+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 08 Dec 2024 06:49:45 +0100

osm2pgsql (2.0.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 03 Dec 2024 06:42:17 +0100

osm2pgsql (2.0.0+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 25 Sep 2024 07:15:23 +0200

osm2pgsql (1.11.0+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Feb 2024 09:03:08 +0100

osm2pgsql (1.10.0+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 13 Nov 2023 05:43:51 +0100

osm2pgsql (1.9.2+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 27 Sep 2023 05:20:33 +0200
