## osm2pgsql 2.1.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
-cmake_minimum_required(VERSION 3.8.0)
-
-project(osm2pgsql VERSION 2.0.1 LANGUAGES CXX C)
+cmake_minimum_required(VERSION 3.10.0)
+
+project(osm2pgsql VERSION 2.1.0 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
@@ -64,10 +64,10 @@
     set(PostgreSQL_TYPE_INCLUDE_DIR /usr/include)
 endif()
 
-set(MINIMUM_POSTGRESQL_SERVER_VERSION "9.6")
-set(MINIMUM_POSTGRESQL_SERVER_VERSION_NUM "90600")
-
-set(PostgreSQL_ADDITIONAL_VERSIONS "17" "16" "15" "14" "13" "12" "11" "10" "9.6")
+set(MINIMUM_POSTGRESQL_SERVER_VERSION "11")
+set(MINIMUM_POSTGRESQL_SERVER_VERSION_NUM "110000")
+
+set(PostgreSQL_ADDITIONAL_VERSIONS "17" "16" "15" "14" "13" "12" "11")
 
 #############################################################
 # Version
@@ -266,7 +266,6 @@
                 src/gen/gen-tile-sql.cpp
                 src/gen/gen-tile-vector.cpp
                 src/gen/gen-tile.cpp
-                src/gen/params.cpp
                 src/gen/raster.cpp
                 src/gen/tracer.cpp)
     target_link_libraries(osm2pgsql-gen osm2pgsql_lib ${LIBS} ${POTRACE_LIBRARY} ${OpenCV_LIBS})
