=== debian/changelog ===
osm2pgsql (2.1.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 08 Apr 2025 05:40:21 +0200
