## osm2pgsql 2.1.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 cmake_minimum_required(VERSION 3.10.0)
 
-project(osm2pgsql VERSION 2.1.0 LANGUAGES CXX C)
+project(osm2pgsql VERSION 2.1.1 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
