=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 set_test(test-domain-matcher LABELS NoDB)
 set_test(test-expire-from-geometry LABELS NoDB)
 set_test(test-expire-tiles LABELS NoDB)
-set_test(test-flex-indexes)
+set_test(test-flex-indexes LABELS NoDB)
 set_test(test-geom-box LABELS NoDB)
 set_test(test-geom-collections LABELS NoDB)
 set_test(test-geom-linestrings LABELS NoDB)
@@ -58,7 +58,7 @@
 set_test(test-geom-polygons LABELS NoDB)
 set_test(test-geom-transform LABELS NoDB)
 set_test(test-json-writer LABELS NoDB)
-set_test(test-lua-utils)
+set_test(test-lua-utils LABELS NoDB)
 set_test(test-middle)
 set_test(test-node-locations LABELS NoDB)
 set_test(test-options-parse LABELS NoDB)
@@ -86,6 +86,7 @@
 set_test(test-output-pgsql-tablespace LABELS Tablespace)
 set_test(test-output-pgsql-validgeom)
 set_test(test-output-pgsql-z_order)
+set_test(test-params LABELS NoDB)
 set_test(test-persistent-cache LABELS NoDB)
 set_test(test-pgsql)
 set_test(test-pgsql-capabilities)
