=== debian/changelog ===
osm2pgsql (2.1.1+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 25 Apr 2025 07:39:42 +0200

osm2pgsql (2.1.1+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 14 Apr 2025 15:30:22 +0200

osm2pgsql (2.1.0+ds-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 13 Apr 2025 06:59:25 +0200
