=== debian/control ===
--- 
+++ 
@@ -28,7 +28,7 @@
                python3-argparse-manpage,
                python3-psycopg2,
                python3-pyosmium
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
 Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git -b bookworm-backports
 Homepage: https://osm2pgsql.org/
