## osm2pgsql 2.2.0%2Bds

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -21,6 +21,7 @@
     flex-lua-expire-output.cpp
     flex-lua-geom.cpp
     flex-lua-index.cpp
+    flex-lua-locator.cpp
     flex-lua-table.cpp
     flex-table-column.cpp
     flex-table.cpp
@@ -31,8 +32,10 @@
     geom-functions.cpp
     geom-pole-of-inaccessibility.cpp
     geom.cpp
+    hex.cpp
     idlist.cpp
     input.cpp
+    locator.cpp
     logging.cpp
     lua-setup.cpp
     lua-utils.cpp
