=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -41,7 +41,6 @@
 set_test(test-check-input LABELS NoDB)
 set_test(test-db-copy-mgr)
 set_test(test-db-copy-thread)
-set_test(test-domain-matcher LABELS NoDB)
 set_test(test-expire-from-geometry LABELS NoDB)
 set_test(test-expire-tiles LABELS NoDB)
 set_test(test-flex-indexes LABELS NoDB)
@@ -57,7 +56,9 @@
 set_test(test-geom-pole-of-inaccessibility LABELS NoDB)
 set_test(test-geom-polygons LABELS NoDB)
 set_test(test-geom-transform LABELS NoDB)
+set_test(test-hex LABELS NoDB)
 set_test(test-json-writer LABELS NoDB)
+set_test(test-locator LABELS NoDB)
 set_test(test-lua-utils LABELS NoDB)
 set_test(test-middle)
 set_test(test-node-locations LABELS NoDB)
