=== debian/control ===
--- 
+++ 
@@ -30,7 +30,7 @@
                python3-pyosmium
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
-Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git -b bookworm-backports
+Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git
 Homepage: https://osm2pgsql.org/
 Rules-Requires-Root: no
