## osm2pgsql 2.2.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 cmake_minimum_required(VERSION 3.10.0)
 
-project(osm2pgsql VERSION 2.1.1 LANGUAGES CXX C)
+project(osm2pgsql VERSION 2.2.0 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
@@ -271,6 +271,9 @@
     target_link_libraries(osm2pgsql-gen osm2pgsql_lib ${LIBS} ${POTRACE_LIBRARY} ${OpenCV_LIBS})
 endif()
 
+add_executable(osm2pgsql-expire src/osm2pgsql-expire.cpp)
+target_link_libraries(osm2pgsql-expire osm2pgsql_lib ${LIBS})
+
 #############################################################
 # Optional "clang-tidy" target
 #############################################################
@@ -286,6 +289,7 @@
 
     add_custom_target(clang-tidy
         ${CLANG_TIDY}
+        --config-file ${CMAKE_SOURCE_DIR}/.clang-tidy
         -p ${CMAKE_BINARY_DIR}
         ${CT_CHECK_FILES}
     )
