=== debian/changelog ===
osm2pgsql (2.2.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 21 Sep 2025 13:56:42 -0700
